//
//  Provehamus.cpp
//  Ice
//  Provehamus is the provehamus for this code.
//
//This part of the code is in Latin as an 

#include "Provehamus.hpp"

namespace var
{
int frame_start_time = 0;
int frame_current_time = 0;
int frame_count = 0;
}

SDL_VideoInfo* sInfo;

int showUI = 1;
int bgFocused = 0;
int fps = 60;
bool quit = false, oglt = true, VB0D = false;

enum keypress {UP_KEY, DOWN_KEY, LEFT_KEY, RIGHT_KEY, W_KEY, A_KEY, S_KEY, D_KEY};
std::map<keypress,bool> kp;

float yrot, xrot;
float xvelocity, zvelocity, zvelocitycache;
vector position, rotation;

float mProjection[16];	/* Projection matrix to load for 'background' */
float mModelview[16];	/* Modelview matrix to load for 'background' */
float mTexture[16];	/* Texture matrix to load for 'background' */

static SDL_Surface *screen;

boost::thread *fusion;

std::map<VType,VBO> VBOMap;

static void menuQuit(AG_Event *event)
{
	AG_Quit();
}
//Scenario Control
void xmlIterate(xmlNode *node, dataplexor *data)
{
}
static void newScenario(AG_Event *event)
{
	//AG_FileDlg *fd = (AG_FileDlg*)AG_SELF();
	char *file = AG_STRING(1);
	//AG_FileType *ft = (AG_FileType*)AG_PTR(2);
	
	dataplexor *data = new dataplexor;
	xmlDocPtr doc;
    doc = xmlReadFile(file, NULL, 0);
    if (doc == NULL) {
        fprintf(stderr, "Failed to parse %s\n", file);
		return;
    }
	
	xmlNode *root = xmlDocGetRootElement(doc);
	
	xmlNode *cur_node = NULL, *child = NULL, *child2 = NULL;
	xmlAttr *attr = NULL;
	
	int xA,yA,zA;
	//Load Scenario Properties
	
	for(attr = root->properties; attr; attr = attr->next)
		{
		if(attr->type = XML_ATTRIBUTE_NODE)
			{
			if (std::string((const char*)attr->name) == std::string("name")) {
					data->simulationName = std::string((const char*)attr->children->content);
			}
		if (std::string((const char*)attr->name) == std::string("X")) {
					xA = atoi((const char*)attr->children->content);
		}
		if (std::string((const char*)attr->name) == std::string("Y")) {
					yA = atoi((const char*)attr->children->content);
		}
		if (std::string((const char*)attr->name) == std::string("Z")) {
					zA = atoi((const char*)attr->children->content);
		}
		if (std::string((const char*)attr->name) == std::string("length")) {
					data->cubeSize = atoi((const char*)attr->children->content);
		}					
		}
		}
	int size;
	if(xA > zA)
		size = xA;
	else
		size = zA;
	if(yA > size)
		size = yA;
	
	glGenBuffers(1, &VBOMap[VGrid].id);
    glGenBuffers(1, &VBOMap[VMass].id);
	
    VBOMap[VGrid].array = (GLfloat*)calloc(pow(size,2)*18, sizeof(GLfloat));
	int u = 0;
	for(int i = 0; i < size; i++)
		{
		for(int x = 0; x < size; x++)
			{
			VBOMap[VGrid].array[u] = x;
			VBOMap[VGrid].array[u+1] = i;
			VBOMap[VGrid].array[u+2] = 0;
			
			VBOMap[VGrid].array[u+3] = x;
			VBOMap[VGrid].array[u+4] = i;
			VBOMap[VGrid].array[u+5] = size;
			u+=6;
			}
		for(int y = 0; y < size; y++)
			{
			VBOMap[VGrid].array[u] = 0;
			VBOMap[VGrid].array[u+1] = y;
			VBOMap[VGrid].array[u+2] = i;
			
			VBOMap[VGrid].array[u+3] = size;
			VBOMap[VGrid].array[u+4] = y;
			VBOMap[VGrid].array[u+5] = i;
			u+=6;
			}
		for(int z = 0; z < size; z++)
			{
			VBOMap[VGrid].array[u] = i;
			VBOMap[VGrid].array[u+1] = 0;
			VBOMap[VGrid].array[u+2] = z;
			
			VBOMap[VGrid].array[u+3] = i;
			VBOMap[VGrid].array[u+4] = size;
			VBOMap[VGrid].array[u+5] = z;
			u+=6;
			}
		}
    VBOMap[VGrid].size = u - 5;
	
    glBindBuffer(GL_ARRAY_BUFFER,VBOMap[VGrid].id);
    glBufferData(GL_ARRAY_BUFFER,sizeof(GLfloat)*VBOMap[VGrid].size,NULL,GL_STATIC_DRAW);
    glBufferSubData(GL_ARRAY_BUFFER,0,sizeof(GLfloat)*VBOMap[VGrid].size,VBOMap[VGrid].array);
    glVertexPointer(3,GL_FLOAT,0,0);
    glVertexAttribPointer(0,3,GL_FLOAT,GL_FALSE,0,0);
    glEnableVertexAttribArray(0);
	

    for (cur_node = root->children; cur_node; cur_node = cur_node->next) {
        if (cur_node->type == XML_ELEMENT_NODE) {
			std::cout<<cur_node->name<<std::endl;
			if (strcmp((const char*)cur_node->name,"mass") == 0) {
				dust mass;
				int id;
				for(attr = cur_node->properties; attr; attr = attr->next)
					{
					if (std::string((const char*)attr->name) == std::string("name")) {
						mass.name = std::string((const char*)attr->children->content);
					}
					if (std::string((const char*)attr->name) == std::string("mass")) {
						mass.mass = atoi((const char*)attr->children->content);
					}
					if (std::string((const char*)attr->name) == std::string("charge")) {
						mass.charge = atoi((const char*)attr->children->content);
					}
					if (std::string((const char*)attr->name) == std::string("id")) {
						id = atoi((const char*)attr->children->content);
					}
					}
				data->dustArray[id] = mass;
			}
			if (strcmp((const char*)cur_node->name,"cube") == 0) {
				vector i;
				for(attr = cur_node->properties; attr; attr = attr->next)
					{
					std::cout<<attr->name<<std::endl;
					if (std::string((const char*)attr->name) == std::string("X")) {
						i.x = atoi((const char*)attr->children->content);
					}
					if (std::string((const char*)attr->name) == std::string("Y")) {
						i.y = atoi((const char*)attr->children->content);
					}
					if (std::string((const char*)attr->name) == std::string("Z")) {
						i.z = atoi((const char*)attr->children->content);
					}
					}
				cube *cOBJ = data->cubeAt(i);
				//cOBJ = new cube();
				for (child2 = cur_node->children; child2; child2 = child2->next)
					{
					if (child2->type == XML_ELEMENT_NODE) {
						if (strcmp((const char*)child2->name,"medium") == 0) {
							int A, B;
							for(attr = child2->properties; attr; attr = attr->next)
								{
								if (std::string((const char*)attr->name) == std::string("id")) {
									A = atoi((const char*)attr->children->content);
								}
								if (std::string((const char*)attr->name) == std::string("mass")) {
									B = atoi((const char*)attr->children->content);
								}
								}
							cOBJ->addDust(A,B);
						}
					}
				}

			}
			if (strcmp((const char*)cur_node->name,"conglomerate") == 0) {

			}
		}
			//Should only be used for testing...
/*
			for(attr = cur_node->properties; attr; attr = attr->next)
			{
			if(attr->type = XML_ATTRIBUTE_NODE)
				{
				printf("	Attribute: %s Value:%s\n", attr->name,attr->children->content);
				}
			   
		for(child = cur_node->children; child; child = child->next)
			{
				if (child->type == XML_ELEMENT_NODE) {
					printf("node type: Element, name: %s\n", child->name);
				}
				for(attr = child->properties; attr; attr = attr->next)
					{
					if(attr->type = XML_ATTRIBUTE_NODE)
						printf("	Attribute: %s Value:%s\n", attr->name,attr->children->content);
					}
				}
			}
 */
}	
    xmlFreeDoc(doc);
	setupScenario(data);
	
	std::cout<<data->cubeArray.size()<<std::endl;
		
	delete(data);
	
	return;

}
static void pauseScenario(AG_Event *event)
{
	stopScenario();
}
static void resumeScenario(AG_Event *event)
{
	startScenario();
}
static void closeScenario(AG_Event *event)
{
	
}

//Window Control
static void preferences(AG_Event *event)
{
}
//File Control
static void openFile(AG_Event *event)
{
	AG_Window *win = AG_WindowNew(0);
    AG_LabelNewStatic(win, 0, "Open Scenario");
	
	AG_FileDlg* dialog = AG_FileDlgNew(win,AG_FILEDLG_CLOSEWIN|AG_FILEDLG_LOAD|AG_FILEDLG_EXPAND);
	AG_FileType *filetype = AG_FileDlgAddType(dialog, "Ice XML", "*.ice", newScenario, NULL);	AG_WindowShow(win);
}
static void saveFile(AG_Event *event)
{
}


void inceptoProvehamus()
{

	position.x = 0;
	position.y = 0;
	position.z = 0;
	yrot = 0;
	xrot = 0;
	rotation.x = 0;
	rotation.y = 0;
	rotation.z = 0;

	zvelocitycache = 0;

    if(!vestibulumReactor(0))
    {

    }
    //Cum finis est per se illato.
//    terminoProvehamus();
}
void terminoProvehamus()
{
    SDL_Quit();
}
bool vestibulumReactor(int plenusscreen)
{
    //SDL_GL_SetAttribute (SDL_GL_DEPTH_SIZE, 24);
    //SDL_GL_SetAttribute (SDL_GL_DOUBLEBUFFER, 1);

    const SDL_VideoInfo *scientiam = SDL_GetVideoInfo();

    Uint32 vexillum = AG_VIDEO_OPENGL;
    int latitudo,altitudo;
    if (plenusscreen)
    {
	        vexillum |= AG_VIDEO_FULLSCREEN;
	        latitudo = scientiam->current_w;
			altitudo = scientiam->current_h;
    }
    else
    {
        latitudo = 800;
        altitudo = 600;
    }
    AG_InitCore("Ice", 0);

    // Create window
	if (AG_InitVideo(latitudo, altitudo, 32, vexillum) == -1) {
        fprintf(stderr, "%s\n", AG_GetError());
        exit(1);
    }
	SDL_Init(SDL_INIT_EVERYTHING);
	initgl();

    // Agar initialization
	setupWindow();


    glGenBuffers(1, &VBOMap[VGrid].id);
    glGenBuffers(1, &VBOMap[VMass].id);

    int size = 50;
    VBOMap[VGrid].array = (GLfloat*)calloc(pow(size,2)*18, sizeof(GLfloat));
	int u = 0;
	for(int i = 0; i < size; i++)
		{
    for(int x = 0; x < size; x++)
		{
		VBOMap[VGrid].array[u] = x;
		VBOMap[VGrid].array[u+1] = i;
		VBOMap[VGrid].array[u+2] = 0;

		VBOMap[VGrid].array[u+3] = x;
		VBOMap[VGrid].array[u+4] = i;
		VBOMap[VGrid].array[u+5] = size;
		u+=6;
		}
	for(int y = 0; y < size; y++)
		{
		VBOMap[VGrid].array[u] = 0;
		VBOMap[VGrid].array[u+1] = y;
		VBOMap[VGrid].array[u+2] = i;

		VBOMap[VGrid].array[u+3] = size;
		VBOMap[VGrid].array[u+4] = y;
		VBOMap[VGrid].array[u+5] = i;
		u+=6;
		}
	for(int z = 0; z < size; z++)
		{
		VBOMap[VGrid].array[u] = i;
		VBOMap[VGrid].array[u+1] = 0;
		VBOMap[VGrid].array[u+2] = z;

		VBOMap[VGrid].array[u+3] = i;
		VBOMap[VGrid].array[u+4] = size;
		VBOMap[VGrid].array[u+5] = z;
		u+=6;
		}
	}
    VBOMap[VGrid].size = u - 5;

    glBindBuffer(GL_ARRAY_BUFFER,VBOMap[VGrid].id);
    glBufferData(GL_ARRAY_BUFFER,sizeof(GLfloat)*VBOMap[VGrid].size,NULL,GL_STATIC_DRAW);
    glBufferSubData(GL_ARRAY_BUFFER,0,sizeof(GLfloat)*VBOMap[VGrid].size,VBOMap[VGrid].array);
    glVertexPointer(3,GL_FLOAT,0,0);
    glVertexAttribPointer(0,3,GL_FLOAT,GL_FALSE,0,0);
    glEnableVertexAttribArray(0);

    eventLoop(AGDRIVER(agDriverSw));
}
void setupWindow()
{
    const SDL_VideoInfo *scientiam = SDL_GetVideoInfo();

    AG_Window *win = AG_WindowNew(0);
    AG_LabelNewStatic(win, 0, "Hello, world!");
    AG_WindowShow(win);

    //Create menubar

    AG_Menu *menu = AG_MenuNewGlobal(0);
    AG_MenuItem *item = AG_MenuNode(menu->root, "Ice", NULL);
		AG_MenuAction(item,"About",NULL,NULL,NULL);
		AG_MenuAction(item,"Preferences...",NULL,NULL,NULL);
		AG_MenuAction(item,"Quit",NULL,menuQuit,NULL);
    item = AG_MenuNode(menu->root, "File", NULL);
		AG_MenuAction(item,"New",NULL,NULL,NULL);
		AG_MenuAction(item,"Open",NULL,openFile,NULL);
		AG_MenuAction(item,"Close",NULL,NULL,NULL);
		AG_MenuAction(item,"Save",NULL,saveFile,NULL);
    item = AG_MenuNode(menu->root, "View", NULL);
		AG_MenuAction(item,"HUD 1",NULL,NULL,NULL);
	item = AG_MenuNode(menu->root, "Control", NULL);
		AG_MenuAction(item,"Start",NULL,resumeScenario,NULL);
		AG_MenuAction(item,"Stop",NULL,pauseScenario,NULL);
    item = AG_MenuNode(menu->root, "Settings", NULL);
		AG_MenuAction(item,"Toggle Fullscreen",NULL,NULL,NULL);

}
void SDLKeyInput(SDL_Event *event)
{
    if(event->type == SDL_KEYDOWN)
    {
       switch(event->key.keysym.sym)
        {
        case SDLK_ESCAPE:
        	AG_Quit();
            break;
            case SDLK_w:
                kp[W_KEY] = true;
                zvelocity = inc;
                break;
            case SDLK_s:
                kp[S_KEY] = true;
                zvelocity = inc;
                break;
            case SDLK_a:
                kp[A_KEY] = true;
                xvelocity = -inc;
                break;
            case SDLK_d:
                kp[D_KEY] = true;
                xvelocity = inc;
                break;
            case SDLK_UP:
                kp[UP_KEY] = true;
				xrot = -rad;
                break;
            case SDLK_DOWN:
                kp[DOWN_KEY] = true;
				xrot = rad;
                break;
            case SDLK_LEFT:
                kp[LEFT_KEY] = true;
				yrot = -rad;
                break;
            case SDLK_RIGHT:
                kp[RIGHT_KEY] = true;
				yrot = rad;
                break;
        default:
            break;

        }
    }
	if(event->type == SDL_KEYUP)
	{
		switch(event->key.keysym.sym)
			{
		case SDLK_w:
		kp[W_KEY] = false;
		zvelocity = 0;
		break;
		case SDLK_s:
		kp[S_KEY] = false;
		zvelocity = 0;
		break;
		case SDLK_a:
		kp[A_KEY] = false;
		xvelocity = 0;
		break;
		case SDLK_d:
		kp[D_KEY] = false;
		xvelocity = 0;
		break;
		case SDLK_UP:
		kp[UP_KEY] = false;
		xrot = 0;
		break;
		case SDLK_DOWN:
		kp[DOWN_KEY] = false;
		xrot = 0;
		break;
		case SDLK_LEFT:
		kp[LEFT_KEY] = false;
		yrot = 0;
		break;
		case SDLK_RIGHT:
		kp[RIGHT_KEY] = false;
		yrot = 0;
		break;
        default:
		break;
			}
		}
}
static int TrapMouseEvent(const AG_DriverEvent *ev) //For later use with mouse/mousewheel.
{
    int rv = 0;
    int x,y;

    switch (ev->type)
    {
    case AG_DRIVER_MOUSE_BUTTON_DOWN:
        x = ev->data.button.x;
        y = ev->data.button.y;

        switch (ev->data.button.which)
        {
        case AG_MOUSE_WHEELUP:
            //vz -= 0.1;
            break;
        case AG_MOUSE_WHEELDOWN:
            //vz += 0.1;
            break;
        }
        return (1);
    }
    return (rv);
}

static int keyCall(const AG_DriverEvent *ev)
{
    return (0);
}

int eventProc(AG_Driver *drv, AG_DriverEvent *ev)
{
    int rv = 0;

    int x,y;

    switch (ev->type)
    {
    case AG_DRIVER_MOUSE_BUTTON_DOWN:
        x = ev->data.button.x;
        y = ev->data.button.y;

        if (showUI && AG_WindowFocusAtPos(AGDRIVER_SW(drv), x,y))
        {
            if (bgFocused)
            {
                bgFocused = 0;
            }
            return AG_ProcessEvent(drv, ev);
        }
        else
        {
            if (bgFocused)
            {
            	AG_ProcessEvent(drv, ev);
                return TrapMouseEvent(ev);
            }
            else
            {
                bgFocused = 1;
            }
        }
        break;
    case AG_DRIVER_VIDEORESIZE:
        rv = AG_ProcessEvent(drv, ev);
        break;
    case AG_DRIVER_KEY_DOWN:
        if (keyCall(ev))
        {
            return (1);
        }
    default:
        if (!bgFocused && showUI)
        {
            rv = AG_ProcessEvent(drv, ev);
        }
        else
        {
            if (TrapMouseEvent(ev) != 1)
            {
                rv = AG_ProcessEvent(drv, ev);
            }
            else
            {
                return (1);
            }
        }
    }

    return (rv);
}

void translate() //Defines movement of perspective of camera
{

	double x = (cos((rotation.x / 180) * pi)*cos((rotation.y / 180) * pi)),y=(sin((rotation.x / 180) * pi)), z = (cos((rotation.x / 180) * pi)*sin((rotation.y / 180) * pi));
	
	rotation.x += xrot;
	rotation.y += yrot;

	if(kp[S_KEY])
		{
		position.x += zvelocity*x;
		position.y += zvelocity*y;
		position.z += zvelocity*z;
		}
	else
		{
		position.x -= zvelocity*x;
		position.y -= zvelocity*y;
		position.z -= zvelocity*z;
		}
	
	if(zvelocity == 0)
		{
		gluLookAt(position.x, position.y, position.z, position.x - zvelocitycache*x, position.y - zvelocitycache*y, position.z - zvelocitycache*z, 0.0f, 1.0f, 0.0f);
		}
	else
		{
		gluLookAt(position.x, position.y, position.z, position.x - zvelocity*x, position.y - zvelocity*y, position.z - zvelocity*z, 0.0f, 1.0f, 0.0f);
		zvelocitycache = zvelocity;
		}
}

void eventLoop(AG_Driver *drv)
{
    SDL_Event event;

    uint now = SDL_GetTicks();
    while(quit == false)
    {
        if(VB0D)
        {
        if(SDL_GetTicks() - now > 20000)
            {
            //UPDATE VAO/VBO
            using namespace boost::interprocess;
            shared_memory_object shm(open_only, memname, read_write);
            mapped_region region(shm, read_write);
            dataplexor *data = static_cast<dataplexor*>(region.get_address());
            scoped_lock<interprocess_upgradable_mutex> lock(data->mutex);
			
            //HERE DO WORK
            GLfloat *array = NULL;
            int arraySize = 0;
            std::map<vector,cube>::iterator it;
            for(it = data->cubeArray.begin(); it != data->cubeArray.end(); it++)
            {
                int points = floor((.1*(*it).second.mass())/data->cubeSize);
                arraySize += 3*points;
                array = (GLfloat*)realloc(array, sizeof(GLfloat)*arraySize);
                for(int i = 0; i < points; i+=3)
                {
                    array[i] = (*it).second.location.x + rand() % 1 - .5;
                    array[i+1] = (*it).second.location.y + rand() % 1 - .5;
                    array[i+2] = (*it).second.location.z + rand() % 1 - .5;
                }
            }
			
            glBindBuffer(GL_ARRAY_BUFFER,VBOMap[VMass].id);
            glBufferData(GL_ARRAY_BUFFER,sizeof(GLfloat)*arraySize,NULL,GL_STATIC_DRAW);
            glBufferSubData(GL_ARRAY_BUFFER,0,sizeof(GLfloat)*arraySize,array);
            glVertexPointer(3,GL_FLOAT,0,0);
            glVertexAttribPointer(0,3,GL_FLOAT,GL_FALSE,0,0);
            glEnableVertexAttribArray(0);

            lock.unlock();
            now = SDL_GetTicks();
            }
        }
        var::frame_start_time = SDL_GetTicks();
        AG_Window *win;
	AG_BeginRendering(drv);

	glMatrixMode(GL_TEXTURE); glPushMatrix(); glLoadMatrixf(mTexture);
    glMatrixMode(GL_PROJECTION); glPushMatrix(); glLoadMatrixf(mProjection);
    glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadMatrixf(mModelview);
    glPushAttrib(GL_ALL_ATTRIB_BITS);
    glEnable(GL_CULL_FACE);
    glDisable(GL_CLIP_PLANE0);
    glDisable(GL_CLIP_PLANE1);
    glDisable(GL_CLIP_PLANE2);
    glDisable(GL_CLIP_PLANE3);
	glClearColor(.5, .5, .5, 0);
	
    /* Draw our background */
    glLoadIdentity();
    glPushAttrib(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
    glEnable(GL_DEPTH_TEST);

	glPushMatrix();
	translate();

	glBindBuffer(GL_ARRAY_BUFFER, VBOMap[VGrid].id);
	glEnableClientState(GL_VERTEX_ARRAY);
//  glEnableClientState(GL_COLOR_ARRAY);
//	std::cout<<VBOMap[VGrid].size<<std::endl;
	glDrawArrays(GL_LINES,0,VBOMap[VGrid].size/3);
//  glDisableClientState(GL_COLOR_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);

	if(VB0D)
	{
	//Draw Grid

	//Draw Density
	glBindBuffer(GL_ARRAY_BUFFER, VBOMap[VMass].id);
	glEnableClientState(GL_VERTEX_ARRAY);
	glDrawArrays(GL_POINTS,0,VBOMap[VMass].size);
	glDisableClientState(GL_VERTEX_ARRAY);
	}

	glBegin(GL_QUADS);
	// top
	glColor3f(1.0f, 0.0f, 0.0f);
	glNormal3f(0.0f, 1.0f, 0.0f);
	glVertex3f(-0.5f, 0.5f, 0.5f);
	glVertex3f(0.5f, 0.5f, 0.5f);
	glVertex3f(0.5f, 0.5f, -0.5f);
	glVertex3f(-0.5f, 0.5f, -0.5f);

	glEnd();

	glBegin(GL_QUADS);
	// front
	glColor3f(0.0f, 1.0f, 0.0f);
	glNormal3f(0.0f, 0.0f, 1.0f);
	glVertex3f(0.5f, -0.5f, 0.5f);
	glVertex3f(0.5f, 0.5f, 0.5f);
	glVertex3f(-0.5f, 0.5f, 0.5f);
	glVertex3f(-0.5f, -0.5f, 0.5f);

	glEnd();

	glBegin(GL_QUADS);
	// right
	glColor3f(0.0f, 0.0f, 1.0f);
	glNormal3f(1.0f, 0.0f, 0.0f);
	glVertex3f(0.5f, 0.5f, -0.5f);
	glVertex3f(0.5f, 0.5f, 0.5f);
	glVertex3f(0.5f, -0.5f, 0.5f);
	glVertex3f(0.5f, -0.5f, -0.5f);

	glEnd();

	glBegin(GL_QUADS);
	// left
	glColor3f(0.0f, 0.0f, 0.5f);
	glNormal3f(-1.0f, 0.0f, 0.0f);
	glVertex3f(-0.5f, -0.5f, 0.5f);
	glVertex3f(-0.5f, 0.5f, 0.5f);
	glVertex3f(-0.5f, 0.5f, -0.5f);
	glVertex3f(-0.5f, -0.5f, -0.5f);

	glEnd();

	glBegin(GL_QUADS);
	// bottom
	glColor3f(0.5f, 0.0f, 0.0f);
	glNormal3f(0.0f, -1.0f, 0.0f);
	glVertex3f(0.5f, -0.5f, 0.5f);
	glVertex3f(-0.5f, -0.5f, 0.5f);
	glVertex3f(-0.5f, -0.5f, -0.5f);
	glVertex3f(0.5f, -0.5f, -0.5f);

	glEnd();

	glBegin(GL_QUADS);
	// back
	glColor3f(0.0f, 0.5f, 0.0f);
	glNormal3f(0.0f, 0.0f, -1.0f);
	glVertex3f(0.5f, 0.5f, -0.5f);
	glVertex3f(0.5f, -0.5f, -0.5f);
	glVertex3f(-0.5f, -0.5f, -0.5f);
	glVertex3f(-0.5f, 0.5f, -0.5f);

	glEnd();
	glPopMatrix();

    glMatrixMode(GL_MODELVIEW); glPopMatrix();
    glMatrixMode(GL_TEXTURE); glPopMatrix();
    glMatrixMode(GL_PROJECTION); glPopMatrix();
    glPopAttrib();
	    glPopAttrib();
        if (showUI)
        {
            AG_LockVFS(drv);
            AG_FOREACH_WINDOW(win, drv)
            {
                AG_ObjectLock(win);
                AG_WindowDraw(win);
                AG_ObjectUnlock(win);
            }
            AG_UnlockVFS(drv);
        }
        AG_EndRendering(drv);


        var::frame_count++;
        var::frame_current_time = SDL_GetTicks();

        if((var::frame_current_time - var::frame_start_time) < (1000/60))
        {
            var::frame_count = 0;
            SDL_Delay((1000/60) - (var::frame_current_time - var::frame_start_time));
        }

        if (SDL_PollEvent(&event) != 0)
        {
            do
            {
                if(event.type == SDL_QUIT)
                {
                    quit = true;
                }
                if(event.type == SDL_KEYDOWN || event.type == SDL_KEYUP)
                {
                    SDLKeyInput(&event);
                }
                AG_DriverEvent ev;
                AG_SDL_TranslateEvent(drv, (const SDL_Event*)&event, &ev);
                if (eventProc(drv, &ev) == -1)
                    return;
            }
            while (SDL_PollEvent(&event) != 0);
        }
    }
}

bool initgl()
{
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
	    GLdouble xMin, xMax, yMin, yMax;
    /* Set a 60 degrees field of view with 1.0 aspect ratio. */
    yMax = 0.01*tan(0.523598f);
    yMin = -yMax;
    xMin = yMin;
    xMax = yMax;
    glFrustum(xMin, xMax, yMin, yMax, 0.01, 100.0);

    //glCullFace( GL_BACK );
    //glFrontFace( GL_CCW );
    //glEnable( GL_CULL_FACE );
	/*
    glEnable(GL_TEXTURE_2D );
    glEnable(GL_DEPTH_TEST);
	glEnable(GL_RESCALE_NORMAL);
    glDepthFunc(GL_ALWAYS);
*/

	//glViewport(0, 0, info->current_w, info->current_h);
/*
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();


	GLdouble aspect = sInfo->current_w/sInfo->current_h;
    gluPerspective(100.0f, aspect, 0.1f, 10000.0f);
 */
/*
	GLdouble fW, fH;
	GLdouble fov = 100.0f;
	fH = tan( (fov / 2) / 180 * pi ) * 0.1f;
	fH = tan( fov / 360 * pi ) * 0.1f;
	fW = fH * aspect;
*/
	//glFrustum( -fW, fW, -fH, fH, 0.1f, 50000.0f );
    glGetFloatv(GL_PROJECTION_MATRIX, mProjection);
    glGetFloatv(GL_MODELVIEW_MATRIX, mModelview);
    glGetFloatv(GL_TEXTURE_MATRIX, mTexture);

    glMatrixMode(GL_PROJECTION); glPopMatrix();
    glMatrixMode(GL_MODELVIEW); glPopMatrix();
    glMatrixMode(GL_TEXTURE); glPopMatrix();

	glClearDepth(1.0f);                         // Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);                        // Enables Depth Testing
	glDepthFunc(GL_LEQUAL);

    //glEnable(GL_LIGHTING);
    //GLfloat global_ambient[] = { 0.75f, 0.75f, 0.75f, 1.0f };
    //glLightModelfv(GL_LIGHT_MODEL_AMBIENT, global_ambient);

    if(glGetError() != GL_NO_ERROR)
    {
        return false;
    }
    return true;
}

//Test Whatnot

void oglTest()
{

}
void coreTest()
{
    dataplexor *space = new dataplexor();
    cube *object;

    int i = 0;
    for(int u = 0; u < 4; u++)
    {
        for(int y = 0; y < 4; y++)
        {
            for(int t = 0; t < 4; t++)
            {
                object = new cube(vector(u,y,t));
                space->
                cubeArray[vector(u,y,t)] = *object;
                i++;
            }
        }
    }

    setupScenario(space);
}
void setupScenario(dataplexor *data)
{
	//First, we must create the shared memory that the scenario is going to be stored in.
   using namespace boost::interprocess;
   try{
      shared_memory_object::remove(memname);
      shared_memory_object shm (create_only, memname, read_write);
      shm.truncate(sizeof(*data));
      mapped_region region(shm, read_write);
      memcpy(region.get_address(),data,sizeof(*data));
      }
   catch(interprocess_exception &ex){
      shared_memory_object::remove(memname);
      std::cout << ex.what() << std::endl;
   }
}
void startScenario()
{
    fusion = new boost::thread(initiateFusion);
    fusion->detach();
}
void stopScenario()
{
	//Send message stating for end of round.
	//Wait for x seconds, if message isn't returned kill fusion thread.
	using namespace boost::interprocess;
	try{
	shared_memory_object shm(open_only, memname, read_write);
    mapped_region region(shm, read_write);
	dataplexor *data = static_cast<dataplexor*>(region.get_address());
	scoped_lock<interprocess_upgradable_mutex> lock(data->mutex);
	data->halt = true;
	lock.unlock();
	}
	catch(interprocess_exception &ex){
		shared_memory_object::remove(memname);
		std::cout << ex.what() << std::endl;
	}
}
void clean_up()
{
}
