#ifndef PROVEHAMUS_H
#define PROVEHAMUS_H
//
//  Provehamus.h
//  Ice
//

#define GL_GLEXT_PROTOTYPES

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <math.h>

#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>

#include <agar/core.h>
#include <agar/gui.h>
#include <agar/gui/opengl.h>
#include <agar/gui/cursors.h>
#include <agar/gui/sdl.h>

#include <boost/thread.hpp>
#include <boost/date_time.hpp>
#include <boost/interprocess/ipc/message_queue.hpp>

#include <libxml/parser.h>
#include <libxml/tree.h>

#include "Core.hpp"

#define BUFFER_OFFSET(i) ((char*)NULL + (i))
#define pi 3.1415926535897932384626433832795
#define inc .2
#define rad 2


enum VType {VGrid, VMass, VCharge};

struct VBO
{
    GLuint id;
    size_t size;
    GLfloat *array;
};

//SDL
void inceptoProvehamus();
void terminoProvehamus();
bool vestibulumReactor(int fullscreen);
void setupWindow();

//Agar
static int TrapMouseEvent(const AG_DriverEvent *ev);
static int keyCall(const AG_DriverEvent *ev);
int eventProc(AG_Driver *drv, AG_DriverEvent *ev);
void eventLoop(AG_Driver *drv);
void menuEventHandler(AG_Event *event);

//OpenGL
bool initgl();
void clean_up();

//Core interaction
dataplexor* loadScenario(std::string path);
void loadSnapshot();
void setupScenario(dataplexor *data);
void startScenario();
void stopScenario();

//Tests
void oglTest();
void coreTest();
#endif PROVEHAMUS_H
